
import controlP5.*;
import controlP5.ControlEvent;


Tweets allTweets;
Tweets dataTweets;
pintarTweet pt;
pintarTweet ptd;
sonoAudio sa;
Tweet t;
ControlP5 cp5;
Tweet tAnterior;



PFont font; 
int frAudio = 150; //variable per controlar el frameRate per reproduir un audio cada 5 segons
int data_consulta;
float boto_consulta;
float eixXMes; 
float eixYMes; 
float eixXDia; 
float eixYDia; 
String textBoto = "all tweets";

void setup() {
  size(1110, 880);
  background(#efefef);
  frameRate(15);

  eixXMes = ((width -30)/31);
  eixYMes = ((height-180)/24.0)+0.1;

  eixXDia = ((width-40)/24.0);
  eixYDia = ((height-180)/60)+0.8;




  noStroke();
  cp5 = new ControlP5(this);

  cp5.setColorCaptionLabel(color(120, 120, 120));
  cp5.setColorBackground(250);
  cp5.setColorActive(color(255, 204, 1));
  cp5.setColorForeground(color(243, 211, 84));

  font = createFont("terminaldosis-light-webfont.ttf", 12);

  cp5.addButton("13")
    .setValue(13)
      .setPosition(325, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("14")
    .setValue(14)
      .setPosition(350, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("15")
    .setValue(15)
      .setPosition(375, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("16")
    .setValue(16)
      .setPosition(400, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("17")
    .setValue(17)
      .setPosition(425, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("18")
    .setValue(18)
      .setPosition(450, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("19")
    .setValue(19)
      .setPosition(475, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("20")
    .setValue(20)
      .setPosition(500, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("21")
    .setValue(21)
      .setPosition(525, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("22")
    .setValue(22)
      .setPosition(550, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("23")
    .setValue(23)
      .setPosition(575, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("24")
    .setValue(24)
      .setPosition(600, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("25")
    .setValue(25)
      .setPosition(625, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("26")
    .setValue(26)
      .setPosition(650, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("27")
    .setValue(27)
      .setPosition(675, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("28")
    .setValue(28)
      .setPosition(700, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("29")
    .setValue(29)
      .setPosition(725, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("30")
    .setValue(30)
      .setPosition(750, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("01")
    .setValue(1)
      .setPosition(800, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("02")
    .setValue(2)
      .setPosition(825, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("03")
    .setValue(3)
      .setPosition(850, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("04")
    .setValue(4)
      .setPosition(875, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("05")
    .setValue(5)
      .setPosition(900, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("06")
    .setValue(6)
      .setPosition(925, 50)
        .setSize(19, 19)

          ;

  cp5.addButton("07")
    .setValue(7)
      .setPosition(950, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("08")
    .setValue(8)
      .setPosition(975, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("09")
    .setValue(9)
      .setPosition(1000, 50)
        .setSize(19, 19)
          ;


  cp5.addButton("10")
    .setValue(10)
      .setPosition(1025, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("11")
    .setValue(11)
      .setPosition(1050, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("12")
    .setValue(12)
      .setPosition(1075, 50)
        .setSize(19, 19)
          ;

  cp5.addButton("All Tweets")
    .setValue(0)
      .setPosition(180, 50)
        .setSize(119, 19)
          ;

  allTweets = new Tweets(this);
  pt = new pintarTweet(allTweets);
  sa = new sonoAudio(this);


  textFont(font, 15);
  textLeading(18);
  fill(#333333); 
  text("Clic on a date to filter", 180, 20, 120, 150);
  textFont(font, 30);
  fill(110); 
  text("May", 325, 5, 120, 150);
  textFont(font, 30);
  fill(110); 
  text("June", 800, 5, 120, 150);
  textFont(font, 18);
  textLeading(20);
  textAlign(LEFT);
  fill(#333333); 
  text("Displaying all Tweets", 20, 15, 120, 150);




  sa.playAudio();
  sa.playAudioAmbient();
  pt.pintaImgsMes();
}

void draw() {

  if (dataTweets == null) {
    RollOverTweetMes();
  }
  else if (boto_consulta == 0) {

    RollOverTweetMes();
  }
  else {

    RollOverTweetDia();
  }


  if (frameCount % frAudio == 0) {
    sa.playAudio();
  }
}

public void controlEvent(ControlEvent theEvent) {
  if (frameCount > 0) {
    data_consulta = int(theEvent.getLabel());
    boto_consulta = theEvent.getValue();
    textBoto = "tweets of day " + theEvent.getLabel();

    if (boto_consulta == 0) {
      pt.pintaImgsMes();
      textBoto = "all tweets";
    }
    dataTweets = new Tweets(this, data_consulta);
    ptd = new pintarTweet(dataTweets);
    ptd.pintaImgsDia();
    noStroke();
    fill(#efefef);
    rect(20, 15, 120, 100);
    textFont(font, 18);
    textLeading(20);
    textAlign(LEFT);
    fill(#333333); 
    text("Displaying " +textBoto, 20, 15, 120, 150);
  }
}




void setupInicialMes() {

  noStroke();
  fill(#fdfdfd);
  rect(0, 80, 1110, 800);

  stroke(#efefef);
  line(35, ((eixYMes)*1)+109, 1090, ((eixYMes)*1)+109);
  line(35, ((eixYMes)*2)+109, 1090, ((eixYMes)*2)+109);
  line(35, ((eixYMes)*3)+109, 1090, ((eixYMes)*3)+109);
  line(35, ((eixYMes)*4)+109, 1090, ((eixYMes)*4)+109);
  line(35, ((eixYMes)*5)+109, 1090, ((eixYMes)*5)+109);
  line(35, ((eixYMes)*6)+109, 1090, ((eixYMes)*6)+109);
  line(35, ((eixYMes)*7)+109, 1090, ((eixYMes)*7)+109);
  line(35, ((eixYMes)*8)+109, 1090, ((eixYMes)*8)+109);
  line(35, ((eixYMes)*9)+109, 1090, ((eixYMes)*9)+109);
  line(35, ((eixYMes)*10)+109, 1090, ((eixYMes)*10)+109);
  line(35, ((eixYMes)*11)+109, 1090, ((eixYMes)*11)+109);
  line(35, ((eixYMes)*12)+109, 1090, ((eixYMes)*12)+109);
  line(35, ((eixYMes)*13)+109, 1090, ((eixYMes)*13)+109);
  line(35, ((eixYMes)*14)+109, 1090, ((eixYMes)*14)+109);
  line(35, ((eixYMes)*15)+109, 1090, ((eixYMes)*15)+109);
  line(35, ((eixYMes)*16)+109, 1090, ((eixYMes)*16)+109);
  line(35, ((eixYMes)*17)+109, 1090, ((eixYMes)*17)+109);
  line(35, ((eixYMes)*18)+109, 1090, ((eixYMes)*18)+109);
  line(35, ((eixYMes)*19)+109, 1090, ((eixYMes)*19)+109);
  line(35, ((eixYMes)*20)+109, 1090, ((eixYMes)*20)+109);
  line(35, ((eixYMes)*21)+109, 1090, ((eixYMes)*21)+109);
  line(35, ((eixYMes)*22)+109, 1090, ((eixYMes)*22)+109);
  line(35, ((eixYMes)*23)+109, 1090, ((eixYMes)*23)+109);
  line(35, ((eixYMes)*24)+109, 1090, ((eixYMes)*24)+109);
  line(35, ((eixYMes)*25)+109, 1090, ((eixYMes)*25)+109);




  pt.pintaImgsMes();

  textFont(font, 18);
  textAlign(CENTER);
  fill(#bdbdbd); 
  text("13", (eixXMes*2-(26)), 90, 32, 32);
  text("14", (eixXMes*3)-(26), 90, 32, 32);
  text("15", (eixXMes*4)-(26), 90, 32, 32);
  text("16", (eixXMes*5)-(26), 90, 32, 32);
  text("17", (eixXMes*6)-(26), 90, 32, 32);
  text("18", (eixXMes*7)-(26), 90, 32, 32);
  text("19", (eixXMes*8)-(26), 90, 32, 32);
  text("20", (eixXMes*9)-(26), 90, 32, 32);
  text("21", (eixXMes*10)-(26), 90, 32, 32);
  text("22", (eixXMes*11)-(26), 90, 32, 32);
  text("23", (eixXMes*12)-(26), 90, 32, 32);
  text("24", (eixXMes*13)-(26), 90, 32, 32);
  text("25", (eixXMes*14)-(26), 90, 32, 32);
  text("26", (eixXMes*15)-(26), 90, 32, 32);
  text("27", (eixXMes*16)-(26), 90, 32, 32);
  text("28", (eixXMes*17)-(26), 90, 32, 32);
  text("29", (eixXMes*18)-(26), 90, 32, 32);
  text("30", (eixXMes*19)-(26), 90, 32, 32);
  text("31", (eixXMes*20)-(26), 90, 32, 32);
  text("01", (eixXMes*21)-(26), 90, 32, 32);
  text("02", (eixXMes*22)-(26), 90, 32, 32);
  text("03", (eixXMes*23)-(26), 90, 32, 32);
  text("04", (eixXMes*24)-(26), 90, 32, 32);
  text("05", (eixXMes*25)-(26), 90, 32, 32);
  text("06", (eixXMes*26)-(26), 90, 32, 32);
  text("07", (eixXMes*27)-(26), 90, 32, 32);
  text("08", (eixXMes*28)-(26), 90, 32, 32);
  text("09", (eixXMes*29)-(26), 90, 32, 32);
  text("10", (eixXMes*30)-(26), 90, 32, 32);
  text("11", (eixXMes*31)-(26), 90, 32, 32);
  text("12", (eixXMes*32)-(26), 90, 32, 32);

  textFont(font, 14);
  text("Dia", 17, 91, 30, 60);
  text("Hora", 5, 107, 30, 60);

  stroke(#efefef);
  line(15, 105, 40, 115);

  textFont(font, 18);
  text("00", 3, ((eixYMes)*1)+110, 32, 32);
  text("01", 3, ((eixYMes)*2)+110, 32, 32);
  text("02", 3, ((eixYMes)*3)+110, 32, 32);
  text("03", 3, ((eixYMes)*4)+110, 32, 32);
  text("04", 3, ((eixYMes)*5)+110, 32, 32);
  text("05", 3, ((eixYMes)*6)+110, 32, 32);
  text("06", 3, ((eixYMes)*7)+110, 32, 32);
  text("07", 3, ((eixYMes)*8)+110, 32, 32);
  text("08", 3, ((eixYMes)*9)+110, 32, 32);
  text("09", 3, ((eixYMes)*10)+110, 32, 32);
  text("10", 3, ((eixYMes)*11)+110, 32, 32);
  text("11", 3, ((eixYMes)*12)+110, 32, 32);
  text("12", 3, ((eixYMes)*13)+110, 32, 32);
  text("13", 3, ((eixYMes)*14)+110, 32, 32);
  text("14", 3, ((eixYMes)*15)+110, 32, 32);
  text("15", 3, ((eixYMes)*16)+110, 32, 32);
  text("16", 3, ((eixYMes)*17)+110, 32, 32);
  text("17", 3, ((eixYMes)*18)+110, 32, 32);
  text("18", 3, ((eixYMes)*19)+110, 32, 32);
  text("19", 3, ((eixYMes)*20)+110, 32, 32);
  text("20", 3, ((eixYMes)*21)+110, 32, 32);
  text("21", 3, ((eixYMes)*22)+110, 32, 32);
  text("22", 3, ((eixYMes)*23)+110, 32, 32);
  text("23", 3, ((eixYMes)*24)+110, 32, 32);
}


void setupInicialDia() {

  noStroke();
  fill(#fdfdfd);
  rect(0, 80, 1110, 800); 

  stroke(#efefef);
  line(35, ((eixYDia)*1)+140, 1090, ((eixYDia)*1)+140);
  line(35, ((eixYDia)*10)+140, 1090, ((eixYDia)*10)+140);
  line(35, ((eixYDia)*20)+140, 1090, ((eixYDia)*20)+140);
  line(35, ((eixYDia)*30)+140, 1090, ((eixYDia)*30)+140);
  line(35, ((eixYDia)*40)+140, 1090, ((eixYDia)*40)+140);
  line(35, ((eixYDia)*50)+140, 1090, ((eixYDia)*50)+140);
  line(35, ((eixYDia)*60)+140, 1090, ((eixYDia)*60)+140);


  ptd.pintaImgsDia();
  textFont(font, 18);
  textAlign(CENTER);
  fill(#bdbdbd); 


  textFont(font, 18);
  text("00", 3, ((eixYDia)*1)+180, 32, 32);
  text("10", 3, ((eixYDia)*10)+190, 32, 32);
  text("20", 3, ((eixYDia)*20)+190, 32, 32);
  text("30", 3, ((eixYDia)*30)+190, 32, 32);
  text("40", 3, ((eixYDia)*40)+190, 32, 32);
  text("50", 3, ((eixYDia)*50)+190, 32, 32);

  textFont(font, 14);
  text("Hora", 17, 91, 30, 60);
  text("Min", 5, 107, 30, 60);

  stroke(#efefef);
  line(15, 105, 40, 115);

  textFont(font, 18);
  text("00", ((eixXDia)*1), 90, 32, 32);
  text("01", ((eixXDia)*2), 90, 32, 32);
  text("02", ((eixXDia)*3), 90, 32, 32);
  text("03", ((eixXDia)*4), 90, 32, 32);
  text("04", ((eixXDia)*5), 90, 32, 32);
  text("05", ((eixXDia)*6), 90, 32, 32);
  text("06", ((eixXDia)*7), 90, 32, 32);
  text("07", ((eixXDia)*8), 90, 32, 32);
  text("08", ((eixXDia)*9), 90, 32, 32);
  text("09", ((eixXDia)*10), 90, 32, 32);
  text("10", ((eixXDia)*11), 90, 32, 32);
  text("11", ((eixXDia)*12), 90, 32, 32);
  text("12", ((eixXDia)*13), 90, 32, 32);
  text("13", ((eixXDia)*14), 90, 32, 32);
  text("14", ((eixXDia)*15), 90, 32, 32);
  text("15", ((eixXDia)*16), 90, 32, 32);
  text("16", ((eixXDia)*17), 90, 32, 32);
  text("17", ((eixXDia)*18), 90, 32, 32);
  text("18", ((eixXDia)*19), 90, 32, 32);
  text("19", ((eixXDia)*20), 90, 32, 32);
  text("20", ((eixXDia)*21), 90, 32, 32);
  text("21", ((eixXDia)*22), 90, 32, 32);
  text("22", ((eixXDia)*23), 90, 32, 32);
  text("23", ((eixXDia)*24), 90, 32, 32);
}



void RollOverTweetMes() {

  t = allTweets.mouseTocaImgMes(mouseX, mouseY);
  if (t == null) {
    setupInicialMes();
  }
  else if (tAnterior!= t) {
    setupInicialMes();
    pt.pintaImgMes(t);
    pt.pintaTextMes(t);

    tAnterior = allTweets.mouseTocaImgMes(mouseX, mouseY);
  }
  else {
    pt.pintaImgMes(t);
    pt.pintaTextMes(t);

    tAnterior = allTweets.mouseTocaImgMes(mouseX, mouseY);
  }
}



void RollOverTweetDia() {
  t = dataTweets.mouseTocaImgDia(mouseX, mouseY);
  if (t == null) {
    setupInicialDia();
  }
  else if (tAnterior!= t) {
    setupInicialDia();
    ptd.pintaImgDia(t);
    ptd.pintaTextDia(t);
    tAnterior = dataTweets.mouseTocaImgDia(mouseX, mouseY);
  }
  else {
    ptd.pintaImgDia(t);
    ptd.pintaTextDia(t);
    tAnterior = dataTweets.mouseTocaImgDia(mouseX, mouseY);
  }
}

